//+------------------------------------------------------------------+
//|                                                    Red&Black.mq4 |
//|                                 Copyright  2008, Gryb Alexander |
//|                                        http://minute-fx.narod.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Gryb Alexander"
#property link      "http://minute-fx.narod.ru"
#define MAGICNUMBER 10000

extern double lots = 1;
extern int slippage = 2;
extern double minR = 0.005;
extern double risk = 0.5;
extern double stopLoss = 0.002;
extern double takeProfit = 0.002;
extern bool MM = false;

extern int max = 0.0100;
extern int step = 0.0010;


int ticket;
double tP;
double sL;
double openBuyPrice[100];
double openSellPrice[100];
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
if(TimeCurrent()==Time[0])
{ 
     int i=0;
     for(double k=0;k<=max;k+=step)
     {

       openBuyPrice[i]= Ask+k;
       openSellPrice[i]= Bid-k;
       i++;
     }
}
    if(MM==true)
     {
       lots = MathRound((AccountFreeMargin()/(Ask*1000))*risk);
       if(lots==0) lots=1;
     }
       CheckForOpen();
       CheckForClose();
//----
   return(0);
}
  
void CheckForOpen()
{ 
 int i=0;
 for(double k = 0;k<=max;k+=step)
 {

  if(Ask==openBuyPrice[i])
  {
   ticket = OrderSend(Symbol(),OP_BUY,lots,Ask,slippage,Bid-stopLoss,Ask+takeProfit,"Expert buy position",MAGICNUMBER); 
  }
  if(Bid==openSellPrice[i])
  {
   ticket = OrderSend(Symbol(),OP_SELL,lots,Bid,slippage,Ask-stopLoss,Bid-takeProfit,"Expert sell position",MAGICNUMBER); 
  }
  i++;
 }
}

void CheckForClose()
{
  for(int k=1;k<=OrdersTotal();k++)
  {
   OrderSelect(k-1,SELECT_BY_POS);
   if((OrderOpenTime()<Time[0]) && (TimeCurrent()==Time[0]))
   { 
     if(OrderType()==OP_BUY) OrderClose(OrderTicket(),OrderLots(),Bid,slippage);
     if(OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask,slippage);
   }
  }
}
//+------------------------------------------------------------------+